> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.getunleash.io/api/release-templates/change-milestone-progression/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.getunleash.io/_mcp/server. # Create or update a milestone progression PUT https://app.unleash-instance.example.com/api/admin/projects/{project}/features/{featureName}/environments/{environment}/progressions/{id} Content-Type: application/json **Enterprise feature** Creates or updates a milestone progression by source milestone ID. If a progression with the given source milestone exists, it will be updated; otherwise, a new one will be created. Reference: https://docs.getunleash.io/api/release-templates/change-milestone-progression ## Authentication - `Authorization` header (required) — API key needed to access this API - `Authorization` header (bearer token, required) — API key needed to access this API, in Bearer token format ## Request ### Path parameters - `project` (string, required) - `featureName` (string, required) - `environment` (string, required) - `id` (string, required) ### Body (application/json) This endpoint expects a changeMilestoneProgressionSchema. - `targetMilestone` (string, required) — The ID of the target milestone - `transitionCondition` (transitionConditionSchema, required) — The condition configuration for the transition ## Response ### 200 #/components/schemas/milestoneProgressionSchema - `sourceMilestone` (string, required) — The ID of the source milestone - `targetMilestone` (string, required) — The ID of the target milestone - `transitionCondition` (transitionConditionSchema, required) — The condition that triggers the transition ## Errors ### 401 Unauthorized Error Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`. - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ### 403 Forbidden Error The provided user credentials are valid, but the user does not have the necessary permissions to perform this operation - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ## Types ### transitionConditionSchema A transition condition for milestone progression ### TransitionConditionSchema0 Transition after a fixed amount of time from milestone start - `intervalMinutes` (integer, required) — The interval in minutes before transitioning - `type` (enum, optional) — Discriminator for time-based transitions. Omitting it means time-based. - Allowed values: `time` ### TransitionConditionSchema1 Transition once the feature has been exposed (evaluated as enabled) enough times in total - `type` (enum, required) — Discriminator for exposure-based transitions - Allowed values: `exposure` - `minimumExposures` (integer, required) — The total number of enabled evaluations of the feature required before transitioning ## Examples **Request** ```json { "targetMilestone": "11K7NXD655W7R89659K58RE07B", "transitionCondition": { "intervalMinutes": 30, "type": "time" } } ``` **Response** ```json { "sourceMilestone": "milestone-1", "targetMilestone": "milestone-2", "transitionCondition": { "intervalMinutes": 30, "type": "time" } } ``` **SDK Code** ```python import requests url = "https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/progressions/id" payload = { "targetMilestone": "11K7NXD655W7R89659K58RE07B", "transitionCondition": { "intervalMinutes": 30, "type": "time" } } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.put(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/progressions/id'; const options = { method: 'PUT', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"targetMilestone":"11K7NXD655W7R89659K58RE07B","transitionCondition":{"intervalMinutes":30,"type":"time"}}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/progressions/id" payload := strings.NewReader("{\n \"targetMilestone\": \"11K7NXD655W7R89659K58RE07B\",\n \"transitionCondition\": {\n \"intervalMinutes\": 30,\n \"type\": \"time\"\n }\n}") req, _ := http.NewRequest("PUT", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/progressions/id") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Put.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"targetMilestone\": \"11K7NXD655W7R89659K58RE07B\",\n \"transitionCondition\": {\n \"intervalMinutes\": 30,\n \"type\": \"time\"\n }\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.put("https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/progressions/id") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"targetMilestone\": \"11K7NXD655W7R89659K58RE07B\",\n \"transitionCondition\": {\n \"intervalMinutes\": 30,\n \"type\": \"time\"\n }\n}") .asString(); ``` ```php request('PUT', 'https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/progressions/id', [ 'body' => '{ "targetMilestone": "11K7NXD655W7R89659K58RE07B", "transitionCondition": { "intervalMinutes": 30, "type": "time" } }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/progressions/id"); var request = new RestRequest(Method.PUT); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"targetMilestone\": \"11K7NXD655W7R89659K58RE07B\",\n \"transitionCondition\": {\n \"intervalMinutes\": 30,\n \"type\": \"time\"\n }\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = [ "targetMilestone": "11K7NXD655W7R89659K58RE07B", "transitionCondition": [ "intervalMinutes": 30, "type": "time" ] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/progressions/id")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "PUT" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```